// ReadBoot.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <windows.h>
#include <iostream>
using namespace std;

void Usage()
{
	cout << "Usage: " << endl << "  readboot [drive]" << endl;
	cout << endl << 
		"To specify a physical drive, use a number to specify the drive. " << endl << 
		"To specify a logical partition, use the specifying letter of the drive." << endl << endl;
}

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE h;

	char outputFile[1024];

	if(argc > 3)
	{
		Usage();
		return 1;
	}
	else if(argc == 1)
	{
		cout << "Opening physical drive 0..." << endl;
		h = CreateFile("\\\\.\\PHYSICALDRIVE0", 
			GENERIC_READ, 
			FILE_SHARE_READ | FILE_SHARE_WRITE, 
			NULL, 
			OPEN_EXISTING, 
			0, 
			NULL);
	}
	else
	{
		char drive = argv[1][0];
		if(strlen(argv[1]) != 1 || !isalnum(drive))
		{
			Usage();
			return 1;
		}
		char fileName[128];
		if(isalpha(drive))
		{
			cout << "Opening logical partition " << drive << "..." << endl;
			strcpy(fileName, "\\\\.\\C:");
			fileName[4] = drive;
		}
		else // Is numeric
		{
			cout << "Opening physical drive " << drive << "..." << endl;
			strcpy(fileName, "\\\\.\\PHYSICALDRIVE0");
			fileName[17] = drive;
		}
		
		h = CreateFile(fileName, 
			GENERIC_READ, 
			FILE_SHARE_READ | FILE_SHARE_WRITE, 
			NULL, 
			OPEN_EXISTING, 
			0, 
			NULL);
	}

	if(argc == 3)
	{
		if(strlen(argv[2]) >= 1023)
		{
			argv[2][1023] = 0;
		}
		
		strcpy(outputFile, argv[2]);
	}
	else
	{
		strcpy(outputFile, "boot.bin");
	}


	if(h == (HANDLE)-1)
	{
		cout << "Error: Could not intialize drive" << endl;
		Usage();
		return 1;
	}

	unsigned char buffer[1024];
	DWORD read = 0;
	
	SetFilePointer(h, (0*512), NULL, FILE_BEGIN);



	BOOL ret = ReadFile(h, buffer, 512, &read, NULL);
	
	if(!ret)
	{
		cout << "Error: Could not read drive" << endl;
		Usage();
		CloseHandle(h);
		return 1;
	}

	ret = CloseHandle(h);

	cout << "Successfully read sector, writing to file " << outputFile << "..." << endl;

	FILE *fp = fopen(outputFile, "wb");
	if(fp)
	{
		fwrite(buffer, 512, 1, fp);

		fclose(fp);
		cout << "Success!" << endl;
	}
	else
	{
		cout << "Error opening output file, operation aborted." << endl;
	}

	return 0;
}

